include:
  - local: .gitlab/ci/qa-common/main.gitlab-ci.yml
  - local: .gitlab/ci/qa-common/rules.gitlab-ci.yml
  - local: .gitlab/ci/qa-common/variables.gitlab-ci.yml

workflow:
  rules:
    - if: '$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH && $SCHEDULE_TYPE == "nightly"'

.ce:
  variables:
    RELEASE: ${REGISTRY_HOST}/${REGISTRY_GROUP}/build/omnibus-gitlab-mirror/gitlab-ce:${CI_COMMIT_SHA}

.ee:
  variables:
    RELEASE: ${REGISTRY_HOST}/${REGISTRY_GROUP}/build/omnibus-gitlab-mirror/gitlab-ee:${CI_COMMIT_SHA}

# ==========================================
# Prepare stage
# ==========================================
trigger-omnibus-env:
  extends:
    - .trigger-omnibus-env

trigger-omnibus:
  extends:
    - .trigger-omnibus
  needs:
    - trigger-omnibus-env

download-knapsack-report:
  extends:
    - .download-knapsack-report
    - .rules:download-knapsack

# ==========================================
# Test stage
# ==========================================

# ------------------------------------------
# Network limiting jobs
# ------------------------------------------
airgapped:
  extends:
    - .qa
    - .ee
    - .parallel
  variables:
    QA_SCENARIO: "Test::Instance::Airgapped"
    QA_RSPEC_TAGS: "--tag '~github' --tag '~skip_live_env'"

instance-image-slow-network:
  extends:
    - .qa
    - .ee
    - .parallel
  variables:
    QA_SIMULATE_SLOW_CONNECTION: "true"

# ------------------------------------------
# N+1 jobs
# ------------------------------------------
nplus1-instance-image:
  extends:
    - .qa
    - .ee
    - .parallel
  variables:
    CACHE_NAMESPACE_NAME: "false"
    GITLAB_QA_OPTS: "--enable-feature gitaly_enforce_requests_limits"

# ------------------------------------------
# Elasticsearch compatibility jobs
# ------------------------------------------
integration-elasticsearch-compatibility-version-7:
  extends:
    - .qa
    - .ee
  variables:
    ELASTIC_VERSION: "7.17.0"
    QA_SCENARIO: "Test::Integration::Elasticsearch"

integration-elasticsearch-compatibility-version-8:
  extends:
    - .qa
    - .ee
  variables:
    ELASTIC_VERSION: "8.6.2"
    QA_SCENARIO: "Test::Integration::Elasticsearch"

# ------------------------------------------
# Opensearch compatibility jobs
# ------------------------------------------
integration-opensearch-compatibility-version-1:
  extends:
    - .qa
    - .ee
  variables:
    OPENSEARCH_VERSION: "1.3.3"
    QA_SCENARIO: "Test::Integration::Opensearch"

integration-opensearch-compatibility-version-2:
  extends:
    - .qa
    - .ee
  variables:
    OPENSEARCH_VERSION: "2.0.1"
    QA_SCENARIO: "Test::Integration::Opensearch"

# ==========================================
# Post test stage
# ==========================================
e2e-test-report:
  extends:
    - .e2e-test-report

upload-knapsack-report:
  extends:
    - .upload-knapsack-report

export-test-metrics:
  extends:
    - .export-test-metrics

generate-test-session:
  extends:
    - .generate-test-session

notify-slack:
  extends:
    - .notify-slack
